package com.citrix.browser.mvpn

import android.app.Activity
import android.content.Context
import com.citrix.Log
import com.citrix.browser.mvpn.TunnelNotificationUtility.notifyTunnelExpiry
import com.citrix.mvpn.ISessionExpiryHandler
import com.citrix.mvpn.TunnelInitializer

object SessionExpiryHandler : ISessionExpiryHandler {
    override fun onSessionExpired(tunnelInitializer: TunnelInitializer, context: Context) {
        val ctxInstanceOfActivity = context is Activity
        Log.d(TunnelConstant.TAG, "SessionExpiryHandler : Session expired while establishing tunnel")
        if (ctxInstanceOfActivity) {
            tunnelInitializer.tunnel()
        } else {
            notifyTunnelExpiry(context)
        }
    }
}