package com.citrix.browser.mvpn

import android.os.Bundle
import com.citrix.Log
import com.citrix.browser.BaseActivity
import com.citrix.browser.R
import com.citrix.browser.mvpn.TunnelNotificationUtility.notifyTunnelExpiry
import com.citrix.mvpn.TunnelInitializer
import com.citrix.mvpn.TunnelUtility

class TunnelExpiryActivity : BaseActivity(), TunnelInitializer.Callback {

    private val mTunnelInitializer: TunnelInitializer = TunnelInitializer(this, this)

    public override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.tunnelexpirydialog);
        Log.d(TunnelConstant.TAG, "Starting: TunnelExpiryActivity")
        if (TunnelUtility.canTunnel(this)) {
            mTunnelInitializer.tunnel()
        } else {
            finish()
        }
    }

    override fun onTunnelEstablished() {
        Log.d(TunnelConstant.TAG, "TunnelExpiryActivity : Tunnel is successfully established")
        finish()
    }

    override fun onFailure() {
        Log.d(TunnelConstant.TAG, "TunnelExpiryActivity : Tunnel couldn't be established")
        finish()
    }

    override fun onSessionExpired() {
        Log.d(TunnelConstant.TAG, "TunnelExpiryActivity : Session expired while establishing tunnel")
        notifyTunnelExpiry(this)
        finish()
    }
}