package com.citrix

import android.content.Context
import com.citrix.sdk.logging.api.Log

object Log {
    /**
     * Priority constant for the println method; use Log.v.
     */
    const val VERBOSE = 2

    /**
     * Priority constant for the println method; use Log.d.
     */
    const val DEBUG = 3

    /**
     * Priority constant for the println method; use Log.i.
     */
    const val INFO = 4

    /**
     * Priority constant for the println method; use Log.w.
     */
    const val WARN = 5

    /**
     * Priority constant for the println method; use Log.e.
     */
    const val ERROR = 6

    /**
     * Priority constant for the println method.
     */
    const val ASSERT = 7

    @JvmStatic
    fun initialize(context: Context) {
    }

    @JvmStatic
    fun wtf(tag: String?, message: String?) {
        Log.wtf(tag, message)
    }

    @JvmStatic
    fun wtf(tag: String?, message: String?, throwable: Throwable?) {
        Log.wtf(tag, message, throwable)
    }

    @JvmStatic
    fun wtf(tag: String?, throwable: Throwable?) {
        Log.wtf(tag, throwable)
    }

    @JvmStatic
    fun e(tag: String?, message: String?) {
        Log.e(tag, message)
    }

    @JvmStatic
    fun e(tag: String?, message: String?, throwable: Throwable?) {
        Log.e(tag, message, throwable)
    }

    @JvmStatic
    fun w(tag: String?, message: String?) {
        Log.w(tag, message)
    }

    @JvmStatic
    fun w(tag: String?, message: String?, throwable: Throwable?) {
        Log.w(tag, message, throwable)
    }

    @JvmStatic
    fun w(tag: String?, throwable: Throwable?) {
        Log.w(tag, throwable)
    }

    @JvmStatic
    fun i(tag: String?, message: String?) {
        Log.i(tag, message)
    }

    @JvmStatic
    fun i(tag: String?, message: String?, throwable: Throwable?) {
        Log.i(tag, message, throwable)
    }

    @JvmStatic
    fun d(tag: String?, message: String?) {
        Log.d(tag, message)
    }

    @JvmStatic
    fun d(tag: String?, message: String?, throwable: Throwable?) {
        Log.d(tag, message, throwable)
    }

    @JvmStatic
    fun v(tag: String?, message: String?) {
        Log.v(tag, message)
    }

    @JvmStatic
    fun v(tag: String?, message: String?, throwable: Throwable?) {
        Log.v(tag, message, throwable)
    }

    @JvmStatic
    fun isLoggable(tag: String?, value: Int): Boolean {
        return Log.isLoggable(tag, value)
    }

    @JvmStatic
    fun getStackTraceString(throwable: Throwable?): String {
        return Log.getStackTraceString(throwable)
    }
}