package com.citrix.mvpn

object SessionExpiryInitializer {
    private lateinit var sessionExpiryHandler: ISessionExpiryHandler

    //Called by applications using MVPN of SecureAppsCommon
    @JvmStatic
    @Synchronized
    fun init(sessionExpiryObject: ISessionExpiryHandler) {
        if(!this::sessionExpiryHandler.isInitialized) {
            sessionExpiryHandler = sessionExpiryObject
        }
    }

    @JvmStatic
    fun getSessionExpiryHandler(): ISessionExpiryHandler? {
        return if(this::sessionExpiryHandler.isInitialized) {
            sessionExpiryHandler
        } else {
            null
        }
    }
}
